=== debian/changelog ===
hyprland (0.52.1+ds-2) unstable; urgency=medium

  [ Julian Sax ]
  * Specify minimum wayland-protocols build-dep version of 1.45.
    Noticed during backporting to trixie, does not build with 1.44
  * Add patch adjusting error message about assets

  [ Chow Loong Jin ]
  * d/patches: Reexport using gbp-pq
  * d/hyprland.install: Don't list all binaries.
    We want to ship all of /usr/bin in the hyprland package, so just list the
    directory. This also resolves an FTBFS in s390x where hyprpm isn't built.
  * d/control: Update build-dep versions

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 18 Nov 2025 18:04:59 +0800

hyprland (0.52.1+ds-1) unstable; urgency=medium

  [ Carl Keinath ]
  * d/clean: make builds reproducible
  * d/copyright: updated copyright holders and files
  * bump Standards-Version to 4.7.2
  * disable hyprpm on big-endian architectures
  * update Homepage field

  [ Chow Loong Jin ]
  * New upstream version 0.52.1+ds (Closes: #1120590)
  * d/control: Bump hyprgraphaics build-dep to match upstream
  * d/patches: Drop upstreamed patches
  * d/patches: Refresh patches
  * d/patches: Fix tests not finding Hyprland binary
  * d/rules: Disable tests

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 18 Nov 2025 11:22:07 +0800
