=== debian/changelog ===
hyprland (0.52.2+ds-1) unstable; urgency=medium

  [ Carl Keinath ]
  * d/clean: add src/version.h
  * d/patches: deterministic shader inclusion order
  * d/rules: add reproducible=+all deb build option
  * Apply Multi-Arch: hint to hyprland-dev
  * d/control: add Recommends: xdg-desktop-portal-hyprland

  [ Chow Loong Jin ]
  * New upstream version 0.52.2+ds
  * d/control: Set Multi-Arch: allowed

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 10 Dec 2025 11:43:26 +0800
