=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
  hyprwayland-scanner (>= 0.3.10),
  libcairo-dev,
  libdrm-dev,
- libxkbcommon-dev,
+ libxkbcommon-dev (>= 1.11.0),
  libegl-dev,
  libegl1-mesa-dev,
  libgbm-dev,
@@ -58,9 +58,12 @@
 
 Package: hyprland
 Architecture: any
+Multi-Arch: allowed
 Depends: ${misc:Depends}, ${shlibs:Depends},
  polkitd, binutils, libgl1-mesa-dri
-Recommends: xwayland
+Recommends:
+ xwayland,
+ xdg-desktop-portal-hyprland,
 Description: Dynamic tiling Wayland compositor
  Hyprland is a dynamic tiling Wayland compositor based on
  wlroots that doesn't sacrifice on its looks. It provides
@@ -86,7 +89,8 @@
 
 Package: hyprland-dev
 Section: libdevel
-Architecture: any
+Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Development files for Hyprland
  Hyprland is a dynamic tiling Wayland compositor based on
