=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 DEB_HOST_ARCH_ENDIAN ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)
 
 # export DH_VERBOSE = 1
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all
 # export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O2
