## hyprland 0.53.3%2Bds

=== debian/changelog ===
hyprland (0.53.3+ds-2) unstable; urgency=medium

  * Move dumpabiver compilation into upstream CMakeLists
  * Refresh patches

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 09 Feb 2026 17:08:59 +0800

hyprland (0.53.3+ds-1) unstable; urgency=medium

  * New upstream version 0.53.3+ds (Closes: #1125297)

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 28 Jan 2026 17:23:31 +0800

hyprland (0.53.1+ds-1) UNRELEASED; urgency=medium

  * New upstream version 0.53.1+ds

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 05 Jan 2026 11:37:27 +0800

hyprland (0.53.0+ds-1) UNRELEASED; urgency=medium

  * d/rules: Include buildflags.mk for CXXFLAGS for dumpabiver
  * d/rules: Add CPPFLAGS and LDFLAGS to dumpabiver compilation.
    Should fix blhc pipeline test
  * New upstream version 0.53.0+ds
  * d/control: Update build-deps to match CMakeLists.txt
  * d/patches: Refresh patches
  * d/control: Build-dep on hyprwire-scanner
  * d/dumpabiver.cpp: Fix compilation error
  * d/copyright: Drop paragraphs for deleted files

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 31 Dec 2025 12:25:58 +0800

hyprland (0.52.2+ds-2) unstable; urgency=medium

  [ Carl Keinath ]
  * d/control: generate Provides: from Hyprland ABI at build time

  [ Chow Loong Jin ]
  * d/control:
    - Update package descriptions
    - Make hyprland-dev depend on its included headers
    - Make hyprland-dev depend on the same version of hyprland
    - Build-dep on libssl-dev
  * Improve debian/dumpabiver
    - Directly use __hyprland_api_get_client_hash() and HYPRLAND_API_VERSION
      from upstream instead of copying the code into debian/
    - Hash the hyprland client hash to get a shorter string for the virtual
      package name
    - Add comments into debian-abi-helper to avoid confusion

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 19 Dec 2025 01:05:59 +0800
